---
title: "yosys4gal: a Yosys Synthesis flow for GAL chips"
description: Bringing modern synthesis to 30-year old technology with Yosys and Rust.
date: 2024-06-14
---

# A History Lesson

During the semiconductor revolution, a dilemma appeared: Designing new ICs required a lot of time and effort to create the mask,
and iteration was expensive. At the time, IC designs were very simple, since the available tools/compute to do tasks like optimization
or place-and-route were limited. And what if you wanted a low-volume design?

To address these concerns, the PAL was born. The principle was straightforward - we use Sum-of-Product notation and place a 2D grid of wires
as a matrix interconnect. By placing tap points at the intersections of the horizontal and vertical wires, we tie them together.

{% image "./pla_logic2.svg", "Hi" %}


hi
